# README #

This is an extension project for the new Unity UI system which can be found at:
[Unity UI Source](https://bitbucket.org/Unity-Technologies/ui)

### What is this repository for? ###

In this repository is a collection of extension scripts to enhance your Unity UI experience. These scripts have been gathered from many sources and combined and improved over time.
(The majority of the scripts came from the Scripts thread on the [Unity UI forum here](http://bit.ly/UnityUIScriptsForumPost))

These include:

* **UIWindowBase**  
A flexible / draggable window script full of fixes from the forum in one place (plus a few tweaks of my own)

* **CurvedText**  
A Text vertex manipulator for those users NOT using TextMeshPro (why ever not?)

* **Gradient**  
Apply vertex colours in a gradient on any UI object

* **RaycastMask**  
An example of an enhanced mask component able to work with the image data. Enables picking on image parts and not just the Rect Transform

* **TabNavigation**  
An example Tb navigation script

*More to come*

### How do I get set up? ###

Either clone / download this repository to your machine and then copy the scripts in, or use the pre-packaged .UnityPackage and import it as a custom package in to your project.

### Contribution guidelines ###

Got a script you want added, then just fork and submit a PR.  All contributions accepted (including fixes)

### Like what you see? ###

All these scripts were put together for my latest book Unity3D UI Essentials
Check out the [page on my blog](http://bit.ly/Unity3DUIEssentials) for more details and learn all about the inner workings of the new Unity UI System.

### The downloads ###
As this repo was created to support my new Unity UI Title ["Unity 3D UI Essentials"](http://bit.ly/Unity3DUIEssentials), in the downloads section you will find two custom assets (SpaceShip-DemoScene-Start.unitypackage and RollABallSample-Start.unitypackage).  These are just here as starter scenes for doing UI tasks in the book.

I will add more sample scenes for the UI examples in this repository and detail them above over time.